Index: /code/branches/FICN/src/audio/AudioIncludes.h
===================================================================
--- /code/branches/FICN/src/audio/AudioIncludes.h	(revision 676)
+++ /code/branches/FICN/src/audio/AudioIncludes.h	(revision 677)
@@ -12,3 +12,2 @@
 
 #include "../orxonox/core/Error.h"
-
Index: /code/branches/FICN/src/audio/AudioStream.cc
===================================================================
--- /code/branches/FICN/src/audio/AudioStream.cc	(revision 676)
+++ /code/branches/FICN/src/audio/AudioStream.cc	(revision 677)
@@ -105,16 +105,16 @@
 		{
 	    COUT(3)
-	        << "version         " << vorbisInfo->version         << "\n"
-	        << "channels        " << vorbisInfo->channels        << "\n"
-	        << "rate (hz)       " << vorbisInfo->rate            << "\n"
-	        << "bitrate upper   " << vorbisInfo->bitrate_upper   << "\n"
-	        << "bitrate nominal " << vorbisInfo->bitrate_nominal << "\n"
-	        << "bitrate lower   " << vorbisInfo->bitrate_lower   << "\n"
-	        << "bitrate window  " << vorbisInfo->bitrate_window  << "\n"
-	        << "\n"
-	        << "vendor " << vorbisComment->vendor << "\n";
+	        << "version         " << vorbisInfo->version         << std::endl
+	        << "channels        " << vorbisInfo->channels        << std::endl
+	        << "rate (hz)       " << vorbisInfo->rate            << std::endl
+	        << "bitrate upper   " << vorbisInfo->bitrate_upper   << std::endl
+	        << "bitrate nominal " << vorbisInfo->bitrate_nominal << std::endl
+	        << "bitrate lower   " << vorbisInfo->bitrate_lower   << std::endl
+	        << "bitrate window  " << vorbisInfo->bitrate_window  << std::endl
+	        << std::endl
+	        << "vendor " << vorbisComment->vendor << std::endl;
 
 	    for(int i = 0; i < vorbisComment->comments; i++)
-	        COUT(3) << "   " << vorbisComment->user_comments[i] << "\n";
+	        COUT(3) << "   " << vorbisComment->user_comments[i] << std::endl;
 
 	    COUT(3) << std::endl;
Index: /code/branches/FICN/src/audio/AudioStream.h
===================================================================
--- /code/branches/FICN/src/audio/AudioStream.h	(revision 676)
+++ /code/branches/FICN/src/audio/AudioStream.h	(revision 677)
@@ -6,39 +6,37 @@
 namespace audio
 {
-	#define BUFFER_SIZE (4096 * 4)
-	
-	class AudioStream
-	{
-	    public:
-					AudioStream(std::string path);
-	        void open();
-	        void release();
-	        void display();
-	        bool playback();
-	        bool playing();
-	        bool update();
-					inline bool isLoaded() { return loaded; }	
+  #define BUFFER_SIZE (4096 * 4)
 
-	    protected:
-	
-	        bool stream(ALuint buffer);
-	        void empty();
-	        void check();
-	        std::string errorString(int code);
-	
-	    private:
-	
-					std::string path;
+  class AudioStream
+  {
+    public:
+      AudioStream(std::string path);
+      void open();
+      void release();
+      void display();
+      bool playback();
+      bool playing();
+      bool update();
+      inline bool isLoaded() { return loaded; }
 
-	        FILE*           oggFile;
-	        OggVorbis_File  oggStream;
-	        vorbis_info*    vorbisInfo;
-	        vorbis_comment* vorbisComment;
-					bool loaded;	
+    protected:
+      bool stream(ALuint buffer);
+      void empty();
+      void check();
+      std::string errorString(int code);
 
-	        ALuint buffers[2];
-	        ALuint source;
-	        ALenum format;
-	};
+    private:
+      std::string path;
+
+      FILE*           oggFile;
+      OggVorbis_File  oggStream;
+      vorbis_info*    vorbisInfo;
+      vorbis_comment* vorbisComment;
+      bool loaded;
+
+      ALuint buffers[2];
+      ALuint source;
+      ALenum format;
+  };
 }
 
Index: /code/branches/FICN/src/loader/LevelLoader.cc
===================================================================
--- /code/branches/FICN/src/loader/LevelLoader.cc	(revision 676)
+++ /code/branches/FICN/src/loader/LevelLoader.cc	(revision 677)
@@ -136,7 +136,8 @@
         mLoadOverlay->show();
 
-        COUT(0) << "\n\n\nThis is Orxonox\nthe hottest 3D action shooter ever to exist\n\n\n";
-        COUT(0) << "Level: " << name() << "\nDescription:" << description() << "\nImage:"<<image()<<"\n\n\n";
-        COUT(4) << "Backgroundcolor: " << loadingBackgroundColor_ << "\nBackgroundimage:" << loadingBackgroundImage_ << "\n\n\n";
+        COUT(0) << "This is Orxonox" << std::endl;
+        COUT(0) << "the hottest 3D action shooter ever to exist" << std::endl;
+        COUT(0) << "Level: " << name() << std::endl << "Description:" << description() << std::endl << "Image:" << image() << std::endl;
+        COUT(4) << "Backgroundcolor: " << loadingBackgroundColor_ << std::endl << "Backgroundimage:" << loadingBackgroundImage_ << std::endl;
 
       }
@@ -162,5 +163,5 @@
               if (elemVal == "ogg")
               {
-        COUT(0) << "Adding sound "<< tElem->Attribute("src") << "\n\n\n";
+                COUT(3) << "Adding sound "<< tElem->Attribute("src") << std::endl;
 
                 auMan->ambientAdd(tElem->Attribute("src"));
@@ -186,10 +187,10 @@
             if (id)
             {
-                          orxonox::BaseObject* obj = id->fabricate();
-                          obj->loadParams(tElem);
+              orxonox::BaseObject* obj = id->fabricate();
+              obj->loadParams(tElem);
             }
             else
             {
-                COUT(2) << "Warning: '"<< tElem->Value() <<"' is not a valid classname.\n";
+                COUT(2) << "Warning: '"<< tElem->Value() <<"' is not a valid classname." << std::endl;
             }
           }
@@ -203,5 +204,5 @@
 
 
-      COUT(0) << "Loading finished!\n\n\n\n\n";
+      COUT(0) << "Loading finished!" << std::endl << std::endl;
     }
   }
Index: /code/branches/FICN/src/orxonox/core/ClassFactory.h
===================================================================
--- /code/branches/FICN/src/orxonox/core/ClassFactory.h	(revision 676)
+++ /code/branches/FICN/src/orxonox/core/ClassFactory.h	(revision 677)
@@ -67,5 +67,5 @@
     bool ClassFactory<T>::create(const std::string& name)
     {
-        COUT(4) << "*** Create entry for " << name << " in Factory.\n";
+        COUT(4) << "*** Create entry for " << name << " in Factory." << std::endl;
         ClassIdentifier<T>::getIdentifier()->addFactory(new ClassFactory<T>);
         Factory::add(name, ClassIdentifier<T>::getIdentifier());
Index: /code/branches/FICN/src/orxonox/core/ConfigValueContainer.cc
===================================================================
--- /code/branches/FICN/src/orxonox/core/ConfigValueContainer.cc	(revision 676)
+++ /code/branches/FICN/src/orxonox/core/ConfigValueContainer.cc	(revision 677)
@@ -57,6 +57,4 @@
         if (!string2Number(this->value_.value_int_, valueString, defvalue))     // Try to convert the string to a value
             this->setConfigFileEntyToDefault();                                 // The conversion failed
-
-        std::cout << "CVC: int: " << this->value_.value_int_ << std::endl;
     }
 
@@ -80,6 +78,4 @@
         if (!string2Number(this->value_.value_uint_, valueString, defvalue))    // Try to convert the string to a value
             this->setConfigFileEntyToDefault();                                 // The conversion failed
-
-        std::cout << "CVC: uint: " << this->value_.value_uint_ << std::endl;
     }
 
Index: /code/branches/FICN/src/orxonox/core/CoreIncludes.h
===================================================================
--- /code/branches/FICN/src/orxonox/core/CoreIncludes.h	(revision 676)
+++ /code/branches/FICN/src/orxonox/core/CoreIncludes.h	(revision 677)
@@ -95,5 +95,5 @@
 */
 #define RegisterObject(ClassName) \
-    COUT(4) << "*** Register Object: " << #ClassName << "\n"; \
+    COUT(4) << "*** Register Object: " << #ClassName << std::endl; \
     InternRegisterObject(ClassName, false)
 
@@ -103,5 +103,5 @@
 */
 #define RegisterRootObject(ClassName) \
-    COUT(4) << "*** Register Root-Object: " << #ClassName << "\n"; \
+    COUT(4) << "*** Register Root-Object: " << #ClassName << std::endl; \
     InternRegisterRootObject(ClassName)
 
Index: /code/branches/FICN/src/orxonox/core/Factory.cc
===================================================================
--- /code/branches/FICN/src/orxonox/core/Factory.cc	(revision 676)
+++ /code/branches/FICN/src/orxonox/core/Factory.cc	(revision 677)
@@ -84,5 +84,5 @@
     void Factory::createClassHierarchy()
     {
-        COUT(3) << "*** Factory -> Create class-hierarchy\n";
+        COUT(3) << "*** Factory -> Create class-hierarchy" << std::endl;
         std::map<std::string, Identifier*>::iterator it;
         it = getFactoryPointer()->identifierStringMap_.begin();
@@ -95,5 +95,5 @@
         }
         (*getFactoryPointer()->identifierStringMap_.begin()).second->stopCreatingHierarchy();
-        COUT(3) << "*** Factory -> Finished class-hierarchy creation\n";
+        COUT(3) << "*** Factory -> Finished class-hierarchy creation" << std::endl;
     }
 
Index: /code/branches/FICN/src/orxonox/core/Identifier.cc
===================================================================
--- /code/branches/FICN/src/orxonox/core/Identifier.cc	(revision 676)
+++ /code/branches/FICN/src/orxonox/core/Identifier.cc	(revision 677)
@@ -68,5 +68,5 @@
     void Identifier::initialize(const IdentifierList* parents)
     {
-        COUT(4) << "*** Initialize " << this->name_ << "-Singleton.\n";
+        COUT(4) << "*** Initialize " << this->name_ << "-Singleton." << std::endl;
         this->bCreatedOneObject_ = true;
 
@@ -97,6 +97,6 @@
         {
             // Abstract classes don't have a factory and therefore can't create new objects
-            COUT(1) << "Error: Cannot create an object of type '" << this->name_ << "'. Class is abstract.\n";
-            COUT(1) << "Aborting...";
+            COUT(1) << "Error: Cannot create an object of type '" << this->name_ << "'. Class is abstract." << std::endl;
+            COUT(1) << "Aborting..." << std::endl;
             abort();
             return NULL;
Index: /code/branches/FICN/src/orxonox/core/Identifier.h
===================================================================
--- /code/branches/FICN/src/orxonox/core/Identifier.h	(revision 676)
+++ /code/branches/FICN/src/orxonox/core/Identifier.h	(revision 677)
@@ -117,5 +117,5 @@
             {
                 hierarchyCreatingCounter_s++;
-                COUT(4) << "*** Increased Hierarchy-Creating-Counter to " << hierarchyCreatingCounter_s << "\n";
+                COUT(4) << "*** Increased Hierarchy-Creating-Counter to " << hierarchyCreatingCounter_s << std::endl;
             }
 
@@ -126,5 +126,5 @@
             {
                 hierarchyCreatingCounter_s--;
-                COUT(4) << "*** Decreased Hierarchy-Creating-Counter to " << hierarchyCreatingCounter_s << "\n";
+                COUT(4) << "*** Decreased Hierarchy-Creating-Counter to " << hierarchyCreatingCounter_s << std::endl;
             }
 
@@ -201,10 +201,10 @@
     ClassIdentifier<T>* ClassIdentifier<T>::registerClass(const IdentifierList* parents, const std::string& name, bool bRootClass)
     {
-        COUT(4) << "*** Register Class in " << name << "-Singleton.\n";
+        COUT(4) << "*** Register Class in " << name << "-Singleton." << std::endl;
 
         // It's a singleton, so maybe we have to create it first
         if (!pointer_s)
         {
-            COUT(4) << "*** Register Class in " << name << "-Singleton -> Create Singleton.\n";
+            COUT(4) << "*** Register Class in " << name << "-Singleton -> Create Singleton." << std::endl;
             pointer_s = new ClassIdentifier();
         }
@@ -214,9 +214,6 @@
         {
             // If no: We have to store the informations and initialize the Identifier
-
-            COUT(4) << "*** Register Class in " << name << "-Singleton -> Initialize Singleton.\n";
+            COUT(4) << "*** Register Class in " << name << "-Singleton -> Initialize Singleton." << std::endl;
             pointer_s->name_ = name;
-//            Factory::add(name, pointer_s); // Add the Identifier to the Factory
-
             if (bRootClass)
                 pointer_s->initialize(NULL); // If a class is derived from two interfaces, the second interface might think it's derived from the first because of the order of constructor-calls. Thats why we set parents to zero in that case.
@@ -236,5 +233,5 @@
         if (!pointer_s)
         {
-            COUT(4) << "*** Create Singleton.\n";
+            COUT(4) << "*** Create Singleton." << std::endl;
             pointer_s = new ClassIdentifier();
         }
@@ -250,5 +247,5 @@
     void ClassIdentifier<T>::addObject(T* object)
     {
-        COUT(4) << "*** Added object to " << ClassIdentifier<T>::getIdentifier()->getName() << "-list.\n";
+        COUT(4) << "*** Added object to " << ClassIdentifier<T>::getIdentifier()->getName() << "-list." << std::endl;
         object->getMetaList().add(ClassIdentifier<T>::getIdentifier()->objects_, ClassIdentifier<T>::getIdentifier()->objects_->add(object));
     }
@@ -285,7 +282,7 @@
                 if (!identifier->isA(ClassIdentifier<T>::getIdentifier()))
                 {
-                    COUT(1) << "Error: Class " << identifier->getName() << " is not a " << ClassIdentifier<T>::getIdentifier()->getName() << "!\n";
-                    COUT(1) << "Error: SubclassIdentifier<" << ClassIdentifier<T>::getIdentifier()->getName() << "> = Class(" << identifier->getName() << ") is forbidden.\n";
-                    COUT(1) << "Aborting...\n";
+                    COUT(1) << "Error: Class " << identifier->getName() << " is not a " << ClassIdentifier<T>::getIdentifier()->getName() << "!" << std::endl;
+                    COUT(1) << "Error: SubclassIdentifier<" << ClassIdentifier<T>::getIdentifier()->getName() << "> = Class(" << identifier->getName() << ") is forbidden." << std::endl;
+                    COUT(1) << "Aborting..." << std::endl;
                     abort();
                 }
@@ -331,12 +328,12 @@
                     if (this->identifier_)
                     {
-                        COUT(1) << "Error: Class " << this->identifier_->getName() << " is not a " << ClassIdentifier<T>::getIdentifier()->getName() << "!\n";
-                        COUT(1) << "Error: Couldn't fabricate a new Object.\n";
-                        COUT(1) << "Aborting...\n";
+                        COUT(1) << "Error: Class " << this->identifier_->getName() << " is not a " << ClassIdentifier<T>::getIdentifier()->getName() << "!" << std::endl;
+                        COUT(1) << "Error: Couldn't fabricate a new Object." << std::endl;
+                        COUT(1) << "Aborting..." << std::endl;
                     }
                     else
                     {
-                        COUT(1) << "Error: Couldn't fabricate a new Object - Identifier is undefined.\n";
-                        COUT(1) << "Aborting...\n";
+                        COUT(1) << "Error: Couldn't fabricate a new Object - Identifier is undefined." << std::endl;
+                        COUT(1) << "Aborting..." << std::endl;
                     }
 
Index: /code/branches/FICN/src/orxonox/core/Iterator.h
===================================================================
--- /code/branches/FICN/src/orxonox/core/Iterator.h	(revision 676)
+++ /code/branches/FICN/src/orxonox/core/Iterator.h	(revision 677)
@@ -151,5 +151,5 @@
                 // Comparing with anything except zero makes no sense
                 if (compare != 0)
-                    COUT(2) << "Warning: Comparing the " << ClassIdentifier<T>::getIdentifier()->getName() << "-List-Iterator with " << compare << " has no effect. Only comparison with 0 works.\n";
+                    COUT(2) << "Warning: Comparing the " << ClassIdentifier<T>::getIdentifier()->getName() << "-List-Iterator with " << compare << " has no effect. Only comparison with 0 works." << std::endl;
 
                 return (this->element_ != 0);
Index: /code/branches/FICN/src/orxonox/core/MetaObjectList.h
===================================================================
--- /code/branches/FICN/src/orxonox/core/MetaObjectList.h	(revision 676)
+++ /code/branches/FICN/src/orxonox/core/MetaObjectList.h	(revision 677)
@@ -70,5 +70,5 @@
 
 
-        COUT(4) << "*** Removing Object from " << ClassIdentifier<T>::getIdentifier()->getName() << "-list.\n";
+        COUT(4) << "*** Removing Object from " << ClassIdentifier<T>::getIdentifier()->getName() << "-list." << std::endl;
         delete this->element_;
     }
Index: /code/branches/FICN/src/orxonox/objects/test1.cc
===================================================================
--- /code/branches/FICN/src/orxonox/objects/test1.cc	(revision 676)
+++ /code/branches/FICN/src/orxonox/objects/test1.cc	(revision 677)
@@ -52,5 +52,5 @@
     void Test1::tick(float dt)
     {
-        std::cout << "Test1: " << this << "\n";
+        std::cout << "Test1: " << this << std::endl;
     }
 
@@ -72,8 +72,8 @@
     void Test1::setUsefullClass1(Identifier* identifier)
     {
-        std::cout << "\n";
-        std::cout << "Test1: usefullClass1->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << "\n";
-        std::cout << "Test1: usefullClass1->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << "\n";
-        std::cout << "Test1: usefullClass1->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << "\n";
+        std::cout << std::endl;
+        std::cout << "Test1: usefullClass1->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << std::endl;
+        std::cout << "Test1: usefullClass1->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << std::endl;
+        std::cout << "Test1: usefullClass1->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << std::endl;
         this->usefullClass1_ = identifier;
     }
@@ -81,8 +81,8 @@
     void Test1::setUsefullClass2(Identifier* identifier)
     {
-        std::cout << "\n";
-        std::cout << "Test1: usefullClass2->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << "\n";
-        std::cout << "Test1: usefullClass2->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << "\n";
-        std::cout << "Test1: usefullClass2->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << "\n";
+        std::cout << std::endl;
+        std::cout << "Test1: usefullClass2->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << std::endl;
+        std::cout << "Test1: usefullClass2->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << std::endl;
+        std::cout << "Test1: usefullClass2->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << std::endl;
         this->usefullClass2_ = identifier;
     }
@@ -90,8 +90,8 @@
     void Test1::setUsefullClassOfTypeTest3(Identifier* identifier)
     {
-        std::cout << "\n";
-        std::cout << "Test1: usefullClass3->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << "\n";
-        std::cout << "Test1: usefullClass3->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << "\n";
-        std::cout << "Test1: usefullClass3->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << "\n";
+        std::cout << std::endl;
+        std::cout << "Test1: usefullClass3->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << std::endl;
+        std::cout << "Test1: usefullClass3->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << std::endl;
+        std::cout << "Test1: usefullClass3->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << std::endl;
         this->usefullClass3_ = identifier;
     }
Index: /code/branches/FICN/src/orxonox/objects/test2.cc
===================================================================
--- /code/branches/FICN/src/orxonox/objects/test2.cc	(revision 676)
+++ /code/branches/FICN/src/orxonox/objects/test2.cc	(revision 677)
@@ -53,15 +53,15 @@
     void Test2::timerFunction1()
     {
-        std::cout << "Test2: 1 Sekunde\n";
+        std::cout << "Test2: 1 Sekunde" << std::endl;
     }
 
     void Test2::timerFunction2()
     {
-        std::cout << "Test2: 5 Sekunden\n";
+        std::cout << "Test2: 5 Sekunden" << std::endl;
     }
 
     void Test2::timerFunction3()
     {
-        std::cout << "Test2: 10 Sekunden sind um!\n";
+        std::cout << "Test2: 10 Sekunden sind um!" << std::endl;
     }
 
@@ -83,8 +83,8 @@
     void Test2::setUsefullClass1(Identifier* identifier)
     {
-        std::cout << "\n";
-        std::cout << "Test2: usefullClass1->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << "\n";
-        std::cout << "Test2: usefullClass1->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << "\n";
-        std::cout << "Test2: usefullClass1->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << "\n";
+        std::cout << std::endl;
+        std::cout << "Test2: usefullClass1->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << std::endl;
+        std::cout << "Test2: usefullClass1->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << std::endl;
+        std::cout << "Test2: usefullClass1->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << std::endl;
         this->usefullClass1_ = identifier;
     }
@@ -92,8 +92,8 @@
     void Test2::setUsefullClass2(Identifier* identifier)
     {
-        std::cout << "\n";
-        std::cout << "Test2: usefullClass2->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << "\n";
-        std::cout << "Test2: usefullClass2->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << "\n";
-        std::cout << "Test2: usefullClass2->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << "\n";
+        std::cout << std::endl;
+        std::cout << "Test2: usefullClass2->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << std::endl;
+        std::cout << "Test2: usefullClass2->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << std::endl;
+        std::cout << "Test2: usefullClass2->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << std::endl;
         this->usefullClass2_ = identifier;
     }
@@ -101,8 +101,8 @@
     void Test2::setUsefullClassOfTypeTest3(Identifier* identifier)
     {
-        std::cout << "\n";
-        std::cout << "Test2: usefullClass3->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << "\n";
-        std::cout << "Test2: usefullClass3->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << "\n";
-        std::cout << "Test2: usefullClass3->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << "\n";
+        std::cout << std::endl;
+        std::cout << "Test2: usefullClass3->isA(Class(Test1)): " << identifier->isA(Class(Test1)) << std::endl;
+        std::cout << "Test2: usefullClass3->isA(Class(Test2)): " << identifier->isA(Class(Test2)) << std::endl;
+        std::cout << "Test2: usefullClass3->isA(Class(Test3)): " << identifier->isA(Class(Test3)) << std::endl;
         this->usefullClass3_ = identifier;
     }
Index: /code/branches/FICN/src/orxonox/objects/test3.cc
===================================================================
--- /code/branches/FICN/src/orxonox/objects/test3.cc	(revision 676)
+++ /code/branches/FICN/src/orxonox/objects/test3.cc	(revision 677)
@@ -78,18 +78,18 @@
 
     #define testandcout(code) \
-      std::cout << #code << " " << code << "\n"
+      std::cout << #code << " " << code << std::endl
 
     void Test3::usefullClassesIsATest(Test1* test1)
     {
-        std::cout << "\n";
-        std::cout << "Test1:\n";
+        std::cout << std::endl;
+        std::cout << "Test1:" << std::endl;
         testandcout(test1->usefullClass1isA(Class(Test1)));
         testandcout(test1->usefullClass1isA(Class(Test2)));
         testandcout(test1->usefullClass1isA(Class(Test3)));
-        std::cout << "\n";
+        std::cout << std::endl;
         testandcout(test1->usefullClass2isA(Class(Test1)));
         testandcout(test1->usefullClass2isA(Class(Test2)));
         testandcout(test1->usefullClass2isA(Class(Test3)));
-        std::cout << "\n";
+        std::cout << std::endl;
         testandcout(test1->usefullClass3isA(Class(Test1)));
         testandcout(test1->usefullClass3isA(Class(Test2)));
@@ -99,14 +99,14 @@
     void Test3::usefullClassesIsATest(Test2* test2)
     {
-        std::cout << "\n";
-        std::cout << "Test2:\n";
+        std::cout << std::endl;
+        std::cout << "Test2:" << std::endl;
         testandcout(test2->usefullClass1isA(Class(Test1)));
         testandcout(test2->usefullClass1isA(Class(Test2)));
         testandcout(test2->usefullClass1isA(Class(Test3)));
-        std::cout << "\n";
+        std::cout << std::endl;
         testandcout(test2->usefullClass2isA(Class(Test1)));
         testandcout(test2->usefullClass2isA(Class(Test2)));
         testandcout(test2->usefullClass2isA(Class(Test3)));
-        std::cout << "\n";
+        std::cout << std::endl;
         testandcout(test2->usefullClass3isA(Class(Test1)));
         testandcout(test2->usefullClass3isA(Class(Test2)));