Index: code/branches/FICN/src/orxonox/objects/weapon_system/BaseWeapon.cc
===================================================================
--- code/branches/FICN/src/orxonox/objects/weapon_system/BaseWeapon.cc	(revision 677)
+++ code/branches/FICN/src/orxonox/objects/weapon_system/BaseWeapon.cc	(revision 680)
@@ -47,14 +47,17 @@
   //CreateFactory(BaseWeapon);
 
-  float BaseWeapon::nextActionValidityPeriod_ = 0.5;
+  float BaseWeapon::nextActionValidityPeriod_s = 0.5;
 
   BaseWeapon::BaseWeapon()
     : sceneMgr_(Orxonox::getSingleton()->getSceneManager()),
-      bulletCounter_(0), primaryFireRequest_(false), currentState_(IDLE),
-      secondaryFireRequest_(false),
+      bulletCounter_(0),
       bulletManager_(Orxonox::getSingleton()->getBulletMgr()),
-      secondaryFired_(false),
-      timeSinceNextActionAdded_(0), actionAdded_(false), nextAction_(NOTHING),
-      ammoDump_(NULL), totalTime_(0.0), leftAmmo_(0)
+      ammoDump_(NULL),
+      primaryFireRequest_(false), secondaryFireRequest_(false),
+      totalTime_(0.0f), actionStartTime_(0.0f),
+      currentState_(IDLE), secondaryFired_(false),
+      nextAction_(NOTHING), actionAdded_(false),
+      timeSinceNextActionAdded_(0.0f),
+      leftAmmo_(0)
   {
     RegisterObject(BaseWeapon);
@@ -102,22 +105,22 @@
     }
 
-    if (currentState_ != IDLE)
+    switch (currentState_)
     {
-      switch (currentState_)
-      {
-      case PRIMARY_FIRE:
-        primaryFiring(totalTime_ - actionStartTime_);
-        break;
+    case IDLE:
+      break;
 
-      case SECONDARY_FIRE:
-        secondaryFiring(totalTime_ - actionStartTime_);
-        break;
+    case PRIMARY_FIRE:
+      primaryFiring(totalTime_ - actionStartTime_);
+      break;
 
-      case RELOADING:
-        break;
+    case SECONDARY_FIRE:
+      secondaryFiring(totalTime_ - actionStartTime_);
+      break;
 
-      case CHANGING_AMMO:
-        break;
-      }
+    case RELOADING:
+      break;
+
+    case CHANGING_AMMO:
+      break;
     }
 
@@ -170,5 +173,5 @@
     secondaryFireRequest_ = false;
 
-    if (totalTime_ - timeSinceNextActionAdded_ > nextActionValidityPeriod_)
+    if (totalTime_ - timeSinceNextActionAdded_ > nextActionValidityPeriod_s)
       nextAction_ = NOTHING;
   }
Index: code/branches/FICN/src/orxonox/objects/weapon_system/BaseWeapon.h
===================================================================
--- code/branches/FICN/src/orxonox/objects/weapon_system/BaseWeapon.h	(revision 677)
+++ code/branches/FICN/src/orxonox/objects/weapon_system/BaseWeapon.h	(revision 680)
@@ -108,5 +108,5 @@
     bool actionAdded_;
     float timeSinceNextActionAdded_;
-    static float nextActionValidityPeriod_;
+    static float nextActionValidityPeriod_s;
 
     // weapon properties
Index: code/branches/FICN/src/orxonox/objects/weapon_system/BulletManager.cc
===================================================================
--- code/branches/FICN/src/orxonox/objects/weapon_system/BulletManager.cc	(revision 677)
+++ code/branches/FICN/src/orxonox/objects/weapon_system/BulletManager.cc	(revision 680)
@@ -37,5 +37,5 @@
   CreateFactory(BulletManager);
 
-  BulletManager::BulletManager() : bulletsIndex_(0), bulletsSize_(8)
+  BulletManager::BulletManager() : bulletsSize_(8), bulletsIndex_(0)
   {
     RegisterObject(BulletManager);
Index: code/branches/FICN/src/orxonox/objects/weapon_system/WeaponStation.cc
===================================================================
--- code/branches/FICN/src/orxonox/objects/weapon_system/WeaponStation.cc	(revision 677)
+++ code/branches/FICN/src/orxonox/objects/weapon_system/WeaponStation.cc	(revision 680)
@@ -42,6 +42,6 @@
 
   WeaponStation::WeaponStation(int stationSize)
-        : stationSize_(stationSize), lastActiveSlotIndex_(-1),
-        slots_(new BaseWeapon*[stationSize])
+        : slots_(new BaseWeapon*[stationSize]),
+          lastActiveSlotIndex_(-1), stationSize_(stationSize)
   {
   	//slots_ = new BaseWeapon*[stationSize];
@@ -59,5 +59,5 @@
   bool WeaponStation::addWeapon(BaseWeapon *weapon)
   {
-    if (lastActiveSlotIndex_ = stationSize_ - 1)
+    if (lastActiveSlotIndex_ == stationSize_ - 1)
       return false;
 