Index: /code/branches/FICN/src/orxonox/core/OrxonoxClass.cc
===================================================================
--- /code/branches/FICN/src/orxonox/core/OrxonoxClass.cc	(revision 696)
+++ /code/branches/FICN/src/orxonox/core/OrxonoxClass.cc	(revision 697)
@@ -38,4 +38,6 @@
     OrxonoxClass::OrxonoxClass()
     {
+        this->setConfigValues();
+
         this->identifier_ = 0;
         this->parents_ = 0;
@@ -43,6 +45,4 @@
         this->bActive_ = true;
         this->bVisible_ = true;
-
-        this->setConfigValues();
     }
 
Index: /code/branches/FICN/src/orxonox/objects/Fighter.cc
===================================================================
--- /code/branches/FICN/src/orxonox/objects/Fighter.cc	(revision 696)
+++ /code/branches/FICN/src/orxonox/objects/Fighter.cc	(revision 697)
@@ -47,5 +47,5 @@
         RegisterObject(Fighter);
 
-        SetConfigValue(bInvertMouse_, false);
+        this->setConfigValues();
 
         this->setMouseEventCallback_ = false;
@@ -104,4 +104,9 @@
     }
 
+    void Fighter::setConfigValues()
+    {
+        SetConfigValue(bInvertMouse_, false);
+    }
+
     void Fighter::setMaxSpeedValues(float maxSpeedForward, float maxSpeedRotateUpDown, float maxSpeedRotateRightLeft, float maxSpeedLoopRightLeft)
     {
Index: /code/branches/FICN/src/orxonox/objects/Fighter.h
===================================================================
--- /code/branches/FICN/src/orxonox/objects/Fighter.h	(revision 696)
+++ /code/branches/FICN/src/orxonox/objects/Fighter.h	(revision 697)
@@ -18,4 +18,5 @@
             Fighter();
             ~Fighter();
+            void setConfigValues();
             virtual void loadParams(TiXmlElement* xmlElem);
             void setMaxSpeedValues(float maxSpeedForward, float maxSpeedRotateUpDown, float maxSpeedRotateRightLeft, float maxSpeedLoopRightLeft);
Index: /code/branches/FICN/src/orxonox/objects/Projectile.cc
===================================================================
--- /code/branches/FICN/src/orxonox/objects/Projectile.cc	(revision 696)
+++ /code/branches/FICN/src/orxonox/objects/Projectile.cc	(revision 697)
@@ -39,8 +39,7 @@
         RegisterObject(Projectile);
 
+        this->setConfigValues();
+
         this->owner_ = owner;
-
-        SetConfigValue(lifetime_, 10.0);
-        SetConfigValue(speed_, 2000.0);
 
         this->billboard_.setBillboardSet("Examples/Flare", ColourValue(1.0, 1.0, 0.5), 1);
@@ -64,4 +63,10 @@
     }
 
+    void Projectile::setConfigValues()
+    {
+        SetConfigValue(lifetime_, 10.0);
+        SetConfigValue(speed_, 2000.0);
+    }
+
     void Projectile::tick(float dt)
     {
@@ -77,5 +82,5 @@
                 if (this->getPosition().squaredDistance(it->getPosition()) <= (radius*radius))
                 {
-                    Explosion* explosion = new Explosion(this);
+                    new Explosion(this);
                     delete this;
                     return;
Index: /code/branches/FICN/src/orxonox/objects/Projectile.h
===================================================================
--- /code/branches/FICN/src/orxonox/objects/Projectile.h	(revision 696)
+++ /code/branches/FICN/src/orxonox/objects/Projectile.h	(revision 697)
@@ -14,4 +14,5 @@
             Projectile(SpaceShip* owner = 0);
             virtual ~Projectile();
+            void setConfigValues();
             void destroyObject();
             virtual void tick(float dt);
Index: /code/branches/FICN/src/orxonox/objects/SpaceShip.cc
===================================================================
--- /code/branches/FICN/src/orxonox/objects/SpaceShip.cc	(revision 696)
+++ /code/branches/FICN/src/orxonox/objects/SpaceShip.cc	(revision 697)
@@ -45,6 +45,5 @@
         RegisterObject(SpaceShip);
 
-        SetConfigValue(bInvertYAxis_, false);
-        SetConfigValue(reloadTime_, 0.125);
+        this->setConfigValues();
 
         this->setMouseEventCallback_ = false;
@@ -123,4 +122,10 @@
     }
 
+    void SpaceShip::setConfigValues()
+    {
+        SetConfigValue(bInvertYAxis_, false);
+        SetConfigValue(reloadTime_, 0.125);
+    }
+
     void SpaceShip::loadParams(TiXmlElement* xmlElem)
     {
@@ -363,6 +368,5 @@
         if (this->bLMousePressed_ && this->timeToReload_ <= 0)
         {
-            // FIXME, unused var; try recycling of projectiles
-            Projectile* proj = new Projectile(this);
+            new Projectile(this);
             this->timeToReload_ = this->reloadTime_;
         }
Index: /code/branches/FICN/src/orxonox/objects/SpaceShip.h
===================================================================
--- /code/branches/FICN/src/orxonox/objects/SpaceShip.h	(revision 696)
+++ /code/branches/FICN/src/orxonox/objects/SpaceShip.h	(revision 697)
@@ -18,4 +18,5 @@
             SpaceShip();
             ~SpaceShip();
+            void setConfigValues();
             virtual void loadParams(TiXmlElement* xmlElem);
             virtual void tick(float dt);